Subject: Re: [Isis-wg] Latitude/Longitude Granularity in https://www.ietf.org/id/draft-shen-isis-geo-coordinates-03.txt

From: Peter Lothberg <[email-masked]>
Date: Wed, 23 Aug 2017 14:40:05 GMT

Acee,

I missed this message as it was just text encoded, no attachments, my
obsolete mail ui can't handle it...

>Hi Peter,
>
>We wanted to assure that milliseconds of latitude/longitude offer
>enough granularity for your applications. This slightly more than 3
>cm granularity for latitude and slightly less the 3 cm granularity
>for longitude. 
>
>Thanks,
>Acee

We have Geo coordinates to form a graph over the network, from cables
and ducts in the ground to the wiring inside a CO/POP/Datacenter.

As Vint Cerf says we need to bring IPv6 to the planet as soon as
March, what we need to future proof this is a format that allows for
the following;

([Galaxy,Solar System,Planet],)* [Operator], [World], [Lat, Long,
Height], [Time of Observation UTC in MJD with decimals]

  (MJD - Modified Julia Date)
  (Operator is the originator/maintainer of the data.)

The proposal is a good start but you lack some important things;

 - You need to be ale to express arbitrary resolution for Lat/Long.

   Depending on the use, you might want to truncate the resolution to
   not reveal the exact location of infrastructure, and then again you
   may want to express exactly where things are. 

   You need to be able to express what we can measure for lat/long
   as an example, so you have to be able to represent this in your
   format:

      LAT 59.317647949 North
      LON 18.023390835 East

- When it comes to height, we really have a problem;

  - Different countries have different ways of measuring the "sea
    level".
  - The sea level are rising
  - The land is also rising, like our Stockholm location is moving 
    about 11mm up and 7mm NE in average every year, so you need to 
    have a date on the observation of the position.
  - The local observations have different ages
  - GPS presented height is done with a theoretical model of the earth
    and calculated based on the distance from the GPS satellite.

   (Neighboring countries in some cases have more than 100cm
    difference in their definition of sea level.)

Height is a signed value, 1mm resolution, with a source identifier
(you need way to add new identifiers for the future);
       - WGS84
       - Local official survey
       - Local height (maybe from basement of building)
       - Local sequence number

- In some cases you want to describe something other than the natural world
  itself. e.g., a VPN described as a flat plane, or military / private
  tectical graph that is a different "plane" / "overlay" etc. 

  So we ended up with a Integer that represents the "world" you are
  describing and the vale of 0 represent the natural world we all live in
  and have as a common reference.

(*) - The astronomers refers to planets in our solar system with a
coordinate system with the sun as 0,0,0. Everything moves, continental
drift to ephemerides of planets and satellites. I chose to leave those
models out of scope as there is enough data in the proposed format to
go to other sources and augment the positions.

-Peter

> --_000_D576E8B0B65A3aceeciscocom_
> Content-Type: text/plain; charset="utf-8"
> Content-Transfer-Encoding: base64
> 
> SGkgUGV0ZXIsDQoNCldlIHdhbnRlZCB0byBhc3N1cmUgdGhhdCBtaWxsaXNlY29uZHMgb2YgbGF0
> aXR1ZGUvbG9uZ2l0dWRlIG9mZmVyIGVub3VnaCBncmFudWxhcml0eSBmb3IgeW91ciBhcHBsaWNh
> dGlvbnMuIFRoaXMgc2xpZ2h0bHkgbW9yZSB0aGFuIDMgY20gZ3JhbnVsYXJpdHkgZm9yIGxhdGl0
> dWRlIGFuZCBzbGlnaHRseSBsZXNzIHRoZSAzIGNtIGdyYW51bGFyaXR5IGZvciBsb25naXR1ZGUu
> DQoNClRoYW5rcywNCkFjZWUNCg==
> 
> --_000_D576E8B0B65A3aceeciscocom_
> Content-Type: text/html; charset="utf-8"
> Content-ID: <[email-masked]>
> Content-Transfer-Encoding: base64
> 
> PGh0bWw+DQo8aGVhZD4NCjxtZXRhIGh0dHAtZXF1aXY9IkNvbnRlbnQtVHlwZSIgY29udGVudD0i
> dGV4dC9odG1sOyBjaGFyc2V0PXV0Zi04Ij4NCjwvaGVhZD4NCjxib2R5IHN0eWxlPSJ3b3JkLXdy
> YXA6IGJyZWFrLXdvcmQ7IC13ZWJraXQtbmJzcC1tb2RlOiBzcGFjZTsgLXdlYmtpdC1saW5lLWJy
> ZWFrOiBhZnRlci13aGl0ZS1zcGFjZTsgY29sb3I6IHJnYigwLCAwLCAwKTsgZm9udC1zaXplOiAx
> NHB4OyBmb250LWZhbWlseTogQ2FsaWJyaSwgc2Fucy1zZXJpZjsiPg0KPGRpdj5IaSBQZXRlciwm
> bmJzcDs8L2Rpdj4NCjxkaXY+PGJyPg0KPC9kaXY+DQo8ZGl2PldlIHdhbnRlZCB0byBhc3N1cmUg
> dGhhdCBtaWxsaXNlY29uZHMgb2YgbGF0aXR1ZGUvbG9uZ2l0dWRlIG9mZmVyIGVub3VnaCBncmFu
> dWxhcml0eSBmb3IgeW91ciBhcHBsaWNhdGlvbnMuIFRoaXMgc2xpZ2h0bHkgbW9yZSB0aGFuIDMg
> Y20gZ3JhbnVsYXJpdHkgZm9yIGxhdGl0dWRlIGFuZCBzbGlnaHRseSBsZXNzIHRoZSAzIGNtIGdy
> YW51bGFyaXR5IGZvciBsb25naXR1ZGUuJm5ic3A7PC9kaXY+DQo8ZGl2Pjxicj4NCjwvZGl2Pg0K
> PGRpdj5UaGFua3MsPC9kaXY+DQo8ZGl2PkFjZWUmbmJzcDs8L2Rpdj4NCjwvYm9keT4NCjwvaHRt
> bD4NCg==
> 
> --_000_D576E8B0B65A3aceeciscocom_--
>

---

From: Peter Lothberg <[email-masked]>
Date: Wed, 23 Aug 2017 10:18:23 GMT

Acee,

      LAT 59.317647949 North
      LON 18.023390835 East

-Peter

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Thu, 24 Aug 2017 13:33:26 +0000

Hi Peter, 

Thanks for your detailed response. One thing we decided since my original
query was to move the YANG geo-location type out of the
ietf-routing-types.yang model since we thought that we didn’t have enough
review and experience to model it correctly. We are going to put it in a
separate YANG model and, based on your response, there may be more than
one YANG type. 

We will be discussing this in the future.

Thanks,
Acee

---

From: Peter Lothberg <[email-masked]>
Date: Thu, 24 Aug 2017 15:33:00 GMT

Acee,

(Thanks for the plain ascii...)

> ietf-routing-types.yang model since we thought that we didnbt have enough

I'm happy to contribute on this, just put me in the loop. 

A generic Yang model for describing a location would be very
useful. Just remember it's not as simple as it first looks. 

I ended up digging into this when we needed to describe the network
as a graph, and you need to describe anything down to the location of
a connector on a panel/device in a building and then what
content/chanel is actually in that fiber/wire . 

> We will be discussing this in the future.

Please keep me in the loop.

--Peter

(ps: we can use a yang model to tell time anywhere in universe to...)